/*
  event_log.h
*/

#ifndef EVENT_LOG_H
#define EVENT_LOG_H

#ifndef DEBUG
#define ENABLE_EVENT_LOG
#endif

#ifdef ENABLE_EVENT_LOG

#define EVENT_LOG_LEN  64

/* all events that can be generated by the xu1541 */
#define EVENT_NONE                    0
#define EVENT_START                   1
#define EVENT_RESET_EXT               2
#define EVENT_RESET_WATCHDOG          3
#define EVENT_RESET_BROWNOUT          4
#define EVENT_TIMEOUT_FREE_BUS        5
#define EVENT_BYTE_NAK                6
#define EVENT_TIMEOUT_LISTENER        7
#define EVENT_WRITE_NO_DEV            8
#define EVENT_WRITE_FAILED            9
#define EVENT_WRITE_DEV_NOT_PRESENT  10
#define EVENT_READ_TIMEOUT           11
#define EVENT_READ_ERROR             12
#define EVENT_TIMEOUT_IEC_WAIT       13

void event_log_init(void);
void event_log_add(unsigned char event);
unsigned char event_log_get(unsigned char index);

#define EVENT(a) event_log_add(a)
#else
#define EVENT(a)
#endif

#endif /* EVENT_LOG_H */
